﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class characterMove : MonoBehaviour {
    Rigidbody playerRigidbody;
    Animator animator;

    Vector3 movement;
    float h;
    float v;
    bool isJump;
    float speed = 3.0f;
    float rotateSpeed = 3.0f;
    // 각종 변수들

    void Awake()
    {
        playerRigidbody = GetComponent<Rigidbody>();
        animator = GetComponent<Animator>();
        // 대상의 리지드바디와 애니메이터를 호출하여 저장합니다.
    }

    void Update()
    {
        h = Input.GetAxisRaw("Horizontal");
        v = Input.GetAxisRaw("Vertical");
        // 키보드 값을 받아옵니다.

        if(Input.GetButtonDown("Jump")) // 스페이스바를 누른지에 대한 여부를 체크합니다.
        {
            isJump = true;
            // 점프 변수를 참으로 돌립니다.
        }
    }

    void FixedUpdate()
    {
        Walk();
        Jump();
        Turn();
        // 옵션 실행을 합니다.
    }

    void Turn()
    {
        if (v == 0 && h == 0) return;   // 만약 입력이 없다면 그대로 리턴합니다.
                                        // 해당 줄이 없다면, 벡터0 방향으로 캐릭터가 자동으로 회전합니다.
        Quaternion newRotation = Quaternion.LookRotation(movement);
        // Quaternion은 회전에 관련하는 함수입니다.
        playerRigidbody.rotation = Quaternion.Slerp(playerRigidbody.rotation, newRotation, rotateSpeed * Time.deltaTime);
        // 부드럽게 회전시키기 위해 Quaternion.Slerp 함수를 이용합니다.
    }
    void Walk()
    {
        if(h == 0 && v == 0)
        {
            animator.SetBool("isWalking", false);
            // 입력이 없다면 isWalking 파라메터를 false로 바꿉니다.
        }
        else
        {
            animator.SetBool("isWalking", true);
            // 그렇지 않다면 true
        }
        movement.Set(h, 0, v);
        // y축을 0으로 고정하고 나머지를 저장합니다.
        movement = movement.normalized * speed * Time.deltaTime;
        // 움직임은 시간에 관여하게 만듭니다.
        // 만약 속도를 올리고 싶다면 speed 변수의 값을 바꿔줍니다.
        playerRigidbody.MovePosition(transform.position + movement);
        // 움직임
    }

    void Jump()
    {
        if (!isJump) return; // 만약 isJump가 별것 없다면 그대로 리턴
        
        if (animator.GetBool("isJump"))
        {// 만약 애니메이터 'isJump 파라메터가 true 라면 false 로 교체합니다.
            animator.SetBool("isJump", false);
            isJump = false;
            // 부울 변수도 false로 체크 변경합니다.
        }

        if(isJump)
        {
            // isJump 변수가 참이라면
            animator.SetBool("isJump", true);
            playerRigidbody.AddForce(Vector3.up * 2.0f, ForceMode.Impulse);
            // 실행합니다.(점프 옵션)
            // AddForce는 원하는 방향으로 힘을 주는 기능입니다.
        }
    }
}
